//FFSubmenu=RAW
//FFName=Konvertiert RAW nach TIF und JPG

//***************************************************
// Namensanhngsel fr die zu speichernden Dateien
// Standardeinstellung: "Bild.raw" wird als "Bild-ff.tif" und "Bild-ff.jpg" gespeichert
//***************************************************

// Namenszusatz fr die zu speichernde JPG-Datei
var jpgNamenszusatz = "-dc";

// Namenszusatz fr die zu speichernde TIFF-Datei
var tifNamenszusatz = "-dc";



var fso = new ActiveXObject("Scripting.FileSystemObject"); 

// Schleife ber alle markierten Bilder   
var imagenum = FF_GetImageCount();
for(var i = 0; i<imagenum ;i++) {
   var path = FF_GetImageName(i);
   var splitPath = SplitPath(path);
      
   // berspringen, was nicht nach Raw aussieht
   if(splitPath.ext.toLowerCase() == ".jpg" || 
      splitPath.ext.toLowerCase() == ".bmp" || 
      splitPath.ext.toLowerCase() == ".png")  {
          continue;
   }
      
   // Bildname im Fortschrittsbalken anzeigen
   FF_SetProgressText(i, imagenum, splitPath.file);

   //***************************************************
   // Raw-Bild laden und konvertieren.
   //    
   //  VT_BOOL FF_LoadRawImage(VT_BSTR name, VT_UI4 flags, VT_R8 denoise, VT_R8 ignored, 
   //                                         VT_I4 highlight, VT_I4 quality, VT_BSTR stuckfile);
   //
   //  VT_BSTR name : Name (Pfad) der RAW-Datei
   //  VT_UI4 flags : Parameter ist eine Summe von
   //                 1 = Halbe Gre
   //                 2 = autom. Weiabgleich
   //                 4 = Kameraweiabgleich
   //                 8 = RGGB als 4 Farbe interpretieren
   //                16 = Bild nach links drehen
   //                32 = Bild nach rechts drehen
   //                64 = Rauschunterdrckung () 
   //               128 = Stuckpixelbeseitigung
   //               256 = Interpolationsqualitt
   //  VT_UI4 denoise : Strke der Rauschunterdrckung ("threshold for wavelet denoising"), 
   //                           nur bei aktiver Rauschunterdrckung (64)
   //  VT_UI4 ignored : unbenutzt (am besten auf 0 setzten)
   //  VT_I4 highlight: Spitzlichterkorrektur ("Highlight mode", [0-9], 0=clip, 1=unclip, 2=blend, 3+=rebuild)
   //  VT_I4 quality  : Interpolationsqualitt ("interpolation quality", [0-3]), 
   //                        nur bei aktiver Interpolationsqualitt (256)
   //  VT_BSTR stuckfile : stuckfile, nur bei aktiver Stuckpixelbeseitigung (128)
   //
   //   Bsp1: "Automatischer Weiabgleich" + "RGGB als 4 Farbe interpretieren"
   //          + "Rauschunterdrckung" ->
   //         FF_LoadRawImage(path, 2 + 8 + 64,    50.0, 0, 0, 0, "")
   //
   //   Bsp2: "Kameraweiabgleich", "Spitzlichterkorrektur mit 5", "Interpolationsqualitt mit 2"
   //         FF_LoadRawImage(path, 4 + 256,    50.0, 0, 5, 2, "")
   //
   // Standardmig wird hier nur der Kameraweiabgleich verwendet: 
   //***************************************************
   // if (!FF_LoadRawImage(path, 4, 50.0, 0, 0, 0, "")) {
       // continue; // Raw-Konversion ist fehlgeschlagen, gehe zum nchsten Bild
   // }
   //***************************************************
   if (!FF_LoadRawImage(path, 4+64+256, 111.0, 0, 2, 3, "")) {
       continue; // Raw-Konversion ist fehlgeschlagen, gehe zum nchsten Bild
   }      
   //***************************************************
   // Bearbeitungen im 16-Bit-Modus
   //  standardmig wird hier Xe847 aufgerufen
   //***** Ende der Raw-Konversion **************************

   // Variante "Kuni"
   // hier kommt eine leichte Aufhellung, die ich fr meine Canon-CR2-Bilder 
   // brauche, um die Helligkeit eines Vergleichs-JPG zu erreichen
   FF_Gamma16(1.2); //war 1.30
 
   //Leichte Schattenaufhellung
   FF_BrightCurve16(131,160,1616,0);

   //eventuell noch eine Kontrastautomatik auf das RAW vor der Konvertierung?
   FF_AutoContrast16();
      
   // Automatische Bildoptimierung mit Xe47
   //FF_Xe847Enhanced16(100, 200, 100, 200, 110, 0, 0, 0);
   
   // Alternative "Perfectly Clear"
   //FF_PerfectlyClear16(true, true, 0, true, 90, true, 55, false, 0, true); 
   
   // Der S-Kontrast16 ist ntig, damit die Kamera-Kontrasteinstellung, 
   // die ich auf besonders gering gestellt habe, ein wenig kompensiert wird
   FF_SContrast16(0.26);
   
   // danach Farbtemperatur einen Hauch klter (passt fr meine 5D und die G10)
   //FF_ColorTemp16(-2); //-6
   //hier wird die Farbtemperatur so angepasst, da der Bildeindruck des konvertierten JPG normal ist. (Ist wegen S-Kontrast ntig geworden)
	//FF_ColorTemp16(-6);

   // Noch eine Kontrastautomatik vor der Umwandlung
   //FF_AutoContrast16();
   
   // alternativ eventuell...
   //FF_BrightUpDown16(-300);
   
   // und falls unten nicht geschrft werden soll, dann gleich hier
   FF_3DSharp16(66, 33);
      
   //***** Ende der 16-Bit-Bearbeitung************************
	  

   // Bild mit den obigen Korrekturen mit Namenszusatz als 16bit-Tiff speichern
   FF_SaveImage16(splitPath.dir + splitPath.file + tifNamenszusatz + ".tif");

   // Bild nach 8bit konvertieren
   FF_Convert16();

   //***************************************************
   // Bearbeitungen im 8-Bit-Modus
   //   beispielsweise knnte man hier Schrfen.
   //***************************************************

   // volle Pulle Kanten schrfen, aber nur wenn oben noch nicht 3d-geschrft ist!!!!
   //FF_SmartSharp(192, 16); 

   // Auch 'ne Option: volle Pulle Schrfen durch Verformen
   // FF_GeoSharp(512) ; 

   //***** Ende der 8-Bit-Bearbeitung*************************
            
   // hier entsteht der neue Dateiname fr das JPG
   var outName = splitPath.dir + splitPath.file + jpgNamenszusatz + ".jpg"; 
      
   // jetzt wird das JPG gespeichert
   FF_SaveImage(outName, 97);

   // Fortschritt melden 
   FF_SetProgress(i+1, imagenum)
}

// Zerteilt einen Bild-Dateinamen in sein Pfadbestandteile
function SplitPath(path) {
    var fso = new ActiveXObject("Scripting.FileSystemObject");
    var    result = new Object();
    result.dir = fso.GetParentFolderName(path) + "\\";
    result.file = fso.GetBaseName(path);
    result.ext = "." + fso.GetExtensionName(path);
    return result;
    }
